// WARNING: DO NOT EDIT THIS FILE. THIS FILE IS MANAGED BY SPRING ROO.
// You may push code into the target .java compilation unit if you wish to edit any member(s).

package com.malsolo.jshop.web;

import com.malsolo.jshop.domain.ElectricalAppliance;
import com.malsolo.jshop.domain.Provider;
import com.malsolo.jshop.domain.StockLine;
import java.io.UnsupportedEncodingException;
import java.lang.Double;
import java.lang.Integer;
import java.lang.Long;
import java.lang.String;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;
import java.util.List;
import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;
import org.springframework.context.i18n.LocaleContextHolder;
import org.springframework.format.annotation.DateTimeFormat;
import org.springframework.ui.Model;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.util.UriUtils;
import org.springframework.web.util.WebUtils;

privileged aspect StockLineController_Roo_Controller {
    
    @RequestMapping(method = RequestMethod.POST)
    public String StockLineController.create(@Valid StockLine stockLine, BindingResult bindingResult, Model uiModel, HttpServletRequest httpServletRequest) {
        if (bindingResult.hasErrors()) {
            uiModel.addAttribute("stockLine", stockLine);
            addDateTimeFormatPatterns(uiModel);
            return "stocklines/create";
        }
        uiModel.asMap().clear();
        stockLine.persist();
        return "redirect:/stocklines/" + encodeUrlPathSegment(stockLine.getId().toString(), httpServletRequest);
    }
    
    @RequestMapping(params = "form", method = RequestMethod.GET)
    public String StockLineController.createForm(Model uiModel) {
        uiModel.addAttribute("stockLine", new StockLine());
        addDateTimeFormatPatterns(uiModel);
        List dependencies = new ArrayList();
        if (Provider.countProviders() == 0) {
            dependencies.add(new String[]{"provider", "providers"});
        }
        uiModel.addAttribute("dependencies", dependencies);
        return "stocklines/create";
    }
    
    @RequestMapping(value = "/{id}", method = RequestMethod.GET)
    public String StockLineController.show(@PathVariable("id") Long id, Model uiModel) {
        addDateTimeFormatPatterns(uiModel);
        uiModel.addAttribute("stockline", StockLine.findStockLine(id));
        uiModel.addAttribute("itemId", id);
        return "stocklines/show";
    }
    
    @RequestMapping(method = RequestMethod.GET)
    public String StockLineController.list(@RequestParam(value = "page", required = false) Integer page, @RequestParam(value = "size", required = false) Integer size, Model uiModel) {
        if (page != null || size != null) {
            int sizeNo = size == null ? 10 : size.intValue();
            uiModel.addAttribute("stocklines", StockLine.findStockLineEntries(page == null ? 0 : (page.intValue() - 1) * sizeNo, sizeNo));
            float nrOfPages = (float) StockLine.countStockLines() / sizeNo;
            uiModel.addAttribute("maxPages", (int) ((nrOfPages > (int) nrOfPages || nrOfPages == 0.0) ? nrOfPages + 1 : nrOfPages));
        } else {
            uiModel.addAttribute("stocklines", StockLine.findAllStockLines());
        }
        addDateTimeFormatPatterns(uiModel);
        return "stocklines/list";
    }
    
    @RequestMapping(method = RequestMethod.PUT)
    public String StockLineController.update(@Valid StockLine stockLine, BindingResult bindingResult, Model uiModel, HttpServletRequest httpServletRequest) {
        if (bindingResult.hasErrors()) {
            uiModel.addAttribute("stockLine", stockLine);
            addDateTimeFormatPatterns(uiModel);
            return "stocklines/update";
        }
        uiModel.asMap().clear();
        stockLine.merge();
        return "redirect:/stocklines/" + encodeUrlPathSegment(stockLine.getId().toString(), httpServletRequest);
    }
    
    @RequestMapping(value = "/{id}", params = "form", method = RequestMethod.GET)
    public String StockLineController.updateForm(@PathVariable("id") Long id, Model uiModel) {
        uiModel.addAttribute("stockLine", StockLine.findStockLine(id));
        addDateTimeFormatPatterns(uiModel);
        return "stocklines/update";
    }
    
    @RequestMapping(value = "/{id}", method = RequestMethod.DELETE)
    public String StockLineController.delete(@PathVariable("id") Long id, @RequestParam(value = "page", required = false) Integer page, @RequestParam(value = "size", required = false) Integer size, Model uiModel) {
        StockLine.findStockLine(id).remove();
        uiModel.asMap().clear();
        uiModel.addAttribute("page", (page == null) ? "1" : page.toString());
        uiModel.addAttribute("size", (size == null) ? "10" : size.toString());
        return "redirect:/stocklines";
    }
    
    @RequestMapping(params = { "find=ByCostBetweenAndProviderAndQuantityBetweenAndStockDateBetween", "form" }, method = RequestMethod.GET)
    public String StockLineController.findStockLinesByCostBetweenAndProviderAndQuantityBetweenAndStockDateBetweenForm(Model uiModel) {
        uiModel.addAttribute("providers", Provider.findAllProviders());
        addDateTimeFormatPatterns(uiModel);
        return "stocklines/findStockLinesByCostBetweenAndProviderAndQuantityBetweenAndStockDateBetween";
    }
    
    @RequestMapping(params = "find=ByCostBetweenAndProviderAndQuantityBetweenAndStockDateBetween", method = RequestMethod.GET)
    public String StockLineController.findStockLinesByCostBetweenAndProviderAndQuantityBetweenAndStockDateBetween(@RequestParam("minCost") Double minCost, @RequestParam("maxCost") Double maxCost, @RequestParam("provider") Provider provider, @RequestParam("minQuantity") Integer minQuantity, @RequestParam("maxQuantity") Integer maxQuantity, @RequestParam("minStockDate") @DateTimeFormat(style = "S-") Date minStockDate, @RequestParam("maxStockDate") @DateTimeFormat(style = "S-") Date maxStockDate, Model uiModel) {
        uiModel.addAttribute("stocklines", StockLine.findStockLinesByCostBetweenAndProviderAndQuantityBetweenAndStockDateBetween(minCost, maxCost, provider, minQuantity, maxQuantity, minStockDate, maxStockDate).getResultList());
        addDateTimeFormatPatterns(uiModel);
        return "stocklines/list";
    }
    
    @ModelAttribute("electricalappliances")
    public Collection<ElectricalAppliance> StockLineController.populateElectricalAppliances() {
        return ElectricalAppliance.findAllElectricalAppliances();
    }
    
    @ModelAttribute("providers")
    public java.util.Collection<Provider> StockLineController.populateProviders() {
        return Provider.findAllProviders();
    }
    
    @ModelAttribute("stocklines")
    public java.util.Collection<StockLine> StockLineController.populateStockLines() {
        return StockLine.findAllStockLines();
    }
    
    void StockLineController.addDateTimeFormatPatterns(Model uiModel) {
        uiModel.addAttribute("stockLine_maxstockdate_date_format", org.joda.time.format.DateTimeFormat.patternForStyle("S-", LocaleContextHolder.getLocale()));
        uiModel.addAttribute("stockLine_minstockdate_date_format", org.joda.time.format.DateTimeFormat.patternForStyle("S-", LocaleContextHolder.getLocale()));
        uiModel.addAttribute("stockLine_stockdate_date_format", org.joda.time.format.DateTimeFormat.patternForStyle("S-", LocaleContextHolder.getLocale()));
    }
    
    String StockLineController.encodeUrlPathSegment(String pathSegment, HttpServletRequest httpServletRequest) {
        String enc = httpServletRequest.getCharacterEncoding();
        if (enc == null) {
            enc = WebUtils.DEFAULT_CHARACTER_ENCODING;
        }
        try {
            pathSegment = UriUtils.encodePathSegment(pathSegment, enc);
        }
        catch (UnsupportedEncodingException uee) {}
        return pathSegment;
    }
    
}
